"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const joi = require("joi");
const schemas_1 = require("./schemas");
exports.Validator = {
    validateStoresConfig(config) {
        return new Promise((resolve, reject) => {
            joi.validate(config, schemas_1.Schemas.storesConfig, (err, value) => {
                if (err) {
                    return reject(err);
                }
                return resolve(value);
            });
        });
    },
    validateModelsConfig(config) {
        return new Promise((resolve, reject) => {
            joi.validate(config, schemas_1.Schemas.modelsConfig, (err, value) => {
                if (err) {
                    return reject(err);
                }
                return resolve(value);
            });
        });
    },
    validateElasticConfig(config) {
        return new Promise((resolve, reject) => {
            joi.validate(config, schemas_1.Schemas.elasticConfig, (err, value) => {
                if (err) {
                    return reject(err);
                }
                return resolve(value);
            });
        });
    }
};
